<?php


class My_Order_Status { //Class Begins

    function __construct(){
        add_action('woocommerce_order_status_changed', array($this,'action_woocommerce_order_status_changed'), 20, 4);
        add_action('woocommerce_order_actions_end', array($this,'add_alert_on_action'));
        add_action( 'admin_enqueue_scripts', array($this,'my_custom_scripts'));
    }

    function add_alert_on_action(){
        /*
        As we are calling my_custom_scripts with callback argument '1', 
        this function is added because call_user_func_array() expects parameter 1 to be a valid callback,
        */
    }

    function my_custom_scripts() {
        wp_register_script( 'my_order_js', plugins_url( 'my_order_status.js', __FILE__ ), array( 'jquery' ) , '1', true);
        wp_enqueue_script( 'my_order_js' );
    }

    function action_woocommerce_order_status_changed($order_id, $status_transition_from, $status_transition_to, $instance){
        // only if previous status was 'on-hold'
        if ($this->is_request_to_rest_api() != 1 && $status_transition_from == 'on-hold'){
            $curl_client = curl_init();
            $quivers_sandbox = get_option('wc_settings_tab_demo_sandbox_status');
            $quivers_apikey = get_option('wc_settings_tab_demo_apikey');
            $is_transition_valid = $this->validateOrderAction($order_id, $quivers_sandbox, $quivers_apikey, $curl_client);
            if (!$is_transition_valid){
                // revert back the status transition
                $order = new WC_Order($order_id);
                $order->update_status('on-hold');
                throw new Exception('Order status cannot be changed from '.$status_transition_from.' to '.$status_transition_to.' , because this order is already shipped by a Retailer.');
                echo "reacehd here";
            }
        }
        else{
        }
    }

    function is_request_to_rest_api() {
        if ( empty( $_SERVER['REQUEST_URI'] ) ) {
          return false;
        }
        $rest_prefix = trailingslashit( rest_get_url_prefix() );
        $woocommerce = ( false !== strpos( $_SERVER['REQUEST_URI'], $rest_prefix . 'wc/' ) );
        // Allow third party plugins use our authentication methods.
        $third_party = ( false !== strpos( $_SERVER['REQUEST_URI'], $rest_prefix . 'wc-' ) );
        return apply_filters( 'woocommerce_rest_is_request_to_rest_api', $woocommerce || $third_party );
      }

    function validateOrderAction($orderId, $quiversSandbox, $quiversAPIKey, $ch) {
        $orderUpdateValidateUrl = 'https://konect.quiversdemo.com/clients/validate/order/';
        if($quiversSandbox == 1) {
           $orderUpdateValidateUrl = "https://konect.quivers.com/clients/validate/order/";
        }
        echo $orderUpdateValidateUrl;
        $payload = array(
           'client_type'=> 'WooCommerce',
           'order_number'=> $orderId,
        );

        curl_setopt($ch, CURLOPT_URL, $orderUpdateValidateUrl);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));  //Post Fields
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $headers = array(
            'Content-Type: application/json',
            'Authorization: apikey '.$quiversAPIKey
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        $server_output = curl_exec ($ch);
        curl_close ($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        if($httpcode!=200) {
           return false;
        }
        $responseDecoded = json_decode($server_output, true);

        foreach ($responseDecoded as $key => $item) {
            if( $item['Value'] == 60 && $item['performed_by'] == 'Retailer' ) {
                return false;
            }
        }
       return true;
   }
}

if( class_exists("My_Order_Status") ) $GLOBALS['my_order_status'] = new My_Order_Status();

?>
